
//  DynaaminenTaulukko.cs  (c) 2005 Kari Laitinen

//  http://www.naturalprogramming.com

//  2005-02-12  Tiedosto luotu.
//  2005-02-12  Viimeisin muutos.

using System ;

class DynaaminenTaulukko
{
   int[] taulukon_muistitila ;

   int   lukujen_maara_taulukossa  =  0 ;
   int   nykyinen_taulukon_koko    =  0 ;

   void  suurenna_tata_taulukkoa( int  haluttu_taulukon_koko )
   {
      if ( haluttu_taulukon_koko  >  nykyinen_taulukon_koko )
      {
         int[]  uusi_taulukon_muistitila  =  new int[ haluttu_taulukon_koko ] ;

         for ( int luvun_indeksi  =  0 ;
                   luvun_indeksi  <  lukujen_maara_taulukossa ;
                   luvun_indeksi  ++ )
         {
            uusi_taulukon_muistitila[ luvun_indeksi ]  =
                                   taulukon_muistitila[ luvun_indeksi ] ;
         }

         taulukon_muistitila     =  uusi_taulukon_muistitila ;
         nykyinen_taulukon_koko  =  haluttu_taulukon_koko ;
      }
   }

   public void lisaa_luku( int luku_taulukon_loppuun )
   {
      if ( nykyinen_taulukon_koko  <=  lukujen_maara_taulukossa )
      {
         suurenna_tata_taulukkoa( lukujen_maara_taulukossa  +  4 ) ;
      }

      taulukon_muistitila[ lukujen_maara_taulukossa ]  =
                                      luku_taulukon_loppuun ;

      lukujen_maara_taulukossa  ++  ;
   }

   public int Length
   {
      get
      {
         return  lukujen_maara_taulukossa ;
      }

      set
      {
         suurenna_tata_taulukkoa( value ) ;

         lukujen_maara_taulukossa  =  value ;
      }
   }

   public int this[ int indeksiarvo ]
   {
      get
      {
         return taulukon_muistitila[ indeksiarvo ] ;
      }

      set
      {
         if ( indeksiarvo  >=  lukujen_maara_taulukossa )
         {
            Console.Write( "\n\n   Liian suuri indeksi: "  +  indeksiarvo ) ;
         }
         else
         {
            taulukon_muistitila[ indeksiarvo ]  =  value ;
         }
      }
   }
}


class DynaamisenTaulukonTestaus
{
   static void Main()
   {
      DynaaminenTaulukko  lukutaulukko  =  new  DynaaminenTaulukko() ;

      for ( int luku_taulukkoon  =   990 ;
                luku_taulukkoon  <  1000 ;
                luku_taulukkoon  ++ )
      {
         lukutaulukko.lisaa_luku( luku_taulukkoon ) ;
      }

      for ( int luvun_indeksi  =  0 ;
                luvun_indeksi  <  lukutaulukko.Length ;
                luvun_indeksi  ++ )
      {
         Console.Write( "   "  +  lukutaulukko[ luvun_indeksi ] ) ;
      }

      lukutaulukko[  3 ]  =  333 ;
      lukutaulukko[ 13 ]  =  888 ;

      lukutaulukko.Length  =  14 ;
      lukutaulukko[ 13 ]   =  888 ;

      Console.Write( "\n\n" ) ;

      for ( int luvun_indeksi  =  0 ;
                luvun_indeksi  <  lukutaulukko.Length ;
                luvun_indeksi  ++ )
      {
         Console.Write( "   "  +  lukutaulukko[ luvun_indeksi ] ) ;
      }
   }
}



